Loading...
Searching...
No Matches
wayland::server::zwp_tablet_pad_group_v2_t Class Reference

a set of buttons, rings and strips More...

`#include <wayland-server-protocol-unstable.hpp>`

## Public Member Functions

std::function< void()> & | on_destroy ()
| destroy the pad object
void | buttons (array_t const &buttons, bool post=true)
| buttons announced
void | ring (bool post=true)
| ring announced
void | strip (bool post=true)
| strip announced
void | modes (uint32_t modes, bool post=true)
| mode-switch ability announced
void | done (bool post=true)
| tablet group description events sequence complete
void | mode_switch (uint32_t time, uint32_t serial, uint32_t mode, bool post=true)
| mode switch event
bool | proxy_has_object () const
| Check whether this wrapper actually wraps an object.
void | post_no_memory () const
uint32_t | get_id () const
client_t | get_client () const
unsigned int | get_version () const
std::string | get_class ()

## Static Public Attributes

static constexpr std::uint32_t | buttons_since_version = 1
| Minimum protocol version required for the buttons function.
static constexpr std::uint32_t | ring_since_version = 1
| Minimum protocol version required for the ring function.
static constexpr std::uint32_t | strip_since_version = 1
| Minimum protocol version required for the strip function.
static constexpr std::uint32_t | modes_since_version = 1
| Minimum protocol version required for the modes function.
static constexpr std::uint32_t | done_since_version = 1
| Minimum protocol version required for the done function.
static constexpr std::uint32_t | mode_switch_since_version = 1
| Minimum protocol version required for the mode_switch function.

## Detailed Description

a set of buttons, rings and strips

A pad group describes a distinct (sub)set of buttons, rings and strips present in the tablet. The criteria of this grouping is usually positional, eg. if a tablet has buttons on the left and right side, 2 groups will be presented. The physical arrangement of groups is undisclosed and may change on the fly.

Pad groups will announce their features during pad initialization. Between the corresponding wp_tablet_pad.group event and wp_tablet_pad_group.done, the pad group will announce the buttons, rings and strips contained in it, plus the number of supported modes.

Modes are a mechanism to allow multiple groups of actions for every element in the pad group. The number of groups and available modes in each is persistent across device plugs. The current mode is user-switchable, it will be announced through the wp_tablet_pad_group.mode_switch event both whenever it is switched, and after wp_tablet_pad.enter.

The current mode logically applies to all elements in the pad group, although it is at clients' discretion whether to actually perform different actions, and/or issue the respective .set_feedback requests to notify the compositor. See the wp_tablet_pad_group.mode_switch event for more details.

Definition at line 5994 of file wayland-server-protocol-unstable.hpp.

## Member Function Documentation

## buttons()

void zwp_tablet_pad_group_v2_t::buttons | ( | array_t const & | buttons,
|  | bool | post = true )

buttons announced

Parameters

  buttons | buttons in this group

Sent on wp_tablet_pad_group initialization to announce the available buttons in the group. Button indices start at 0, a button may only be in one group at a time.

This event is first sent in the initial burst of events before the wp_tablet_pad_group.done event.

Some buttons are reserved by the compositor. These buttons may not be assigned to any wp_tablet_pad_group. Compositors may broadcast this event in the case of changes to the mapping of these reserved buttons. If the compositor happens to reserve all buttons in a group, this event will be sent with an empty array.

Definition at line 6839 of file wayland-server-protocol-unstable.cpp.

## done()

void zwp_tablet_pad_group_v2_t::done | ( | bool | post = true | ) |

tablet group description events sequence complete

This event is sent immediately to signal the end of the initial burst of descriptive events. A client may consider the static description of the tablet to be complete and finalize initialization of the tablet group.

Definition at line 6859 of file wayland-server-protocol-unstable.cpp.

## get_class()

std::string wayland::server::resource_t::get_class | ( |  | ) |

inherited

Retrieve the interface name (class) of a resource object.

Returns
  Interface name of the resource object.

## get_client()

client_t wayland::server::resource_t::get_client | ( |  | ) | const

inherited

Get the associated client

Returns
  the client that owns the resource.

## get_id()

uint32_t wayland::server::resource_t::get_id | ( |  | ) | const

inherited

Get the internal ID of the resource

Returns
  the internal ID of the resource

## get_version()

unsigned int wayland::server::resource_t::get_version | ( |  | ) | const

inherited

Get interface version

Returns
  Interface version this resource has been constructed with.

## mode_switch()

void zwp_tablet_pad_group_v2_t::mode_switch | ( | uint32_t | time,
|  | uint32_t | serial,
|  | uint32_t | mode,
|  | bool | post = true )

mode switch event

Parameters

  time | the time of the event with millisecond granularity
  serial |
  mode | the new mode of the pad

Notification that the mode was switched.

A mode applies to all buttons, rings and strips in a group simultaneously, but a client is not required to assign different actions for each mode. For example, a client may have mode-specific button mappings but map the ring to vertical scrolling in all modes. Mode indices start at 0.

Switching modes is compositor-dependent. The compositor may provide visual cues to the client about the mode, e.g. by toggling LEDs on the tablet device. Mode-switching may be software-controlled or controlled by one or more physical buttons. For example, on a Wacom Intuos Pro, the button inside the ring may be assigned to switch between modes.

The compositor will also send this event after wp_tablet_pad.enter on each group in order to notify of the current mode. Groups that only feature one mode will use mode=0 when emitting this event.

If a button action in the new mode differs from the action in the previous mode, the client should immediately issue a wp_tablet_pad.set_feedback request for each changed button.

If a ring or strip action in the new mode differs from the action in the previous mode, the client should immediately issue a wp_tablet_ring.set_feedback or wp_tablet_strip.set_feedback request for each changed ring or strip.

Definition at line 6864 of file wayland-server-protocol-unstable.cpp.

## modes()

void zwp_tablet_pad_group_v2_t::modes | ( | uint32_t | modes,
|  | bool | post = true )

mode-switch ability announced

Parameters

  modes | the number of modes

Sent on wp_tablet_pad_group initialization to announce that the pad group may switch between modes. A client may use a mode to store a specific configuration for buttons, rings and strips and use the wl_tablet_pad_group.mode_switch event to toggle between these configurations. Mode indices start at 0.

Switching modes is compositor-dependent. See the wp_tablet_pad_group.mode_switch event for more details.

This event is sent in the initial burst of events before the wp_tablet_pad_group.done event. This event is only sent when more than more than one mode is available.

Definition at line 6854 of file wayland-server-protocol-unstable.cpp.

## on_destroy()

std::function< void()> & zwp_tablet_pad_group_v2_t::on_destroy | ( |  | ) |

destroy the pad object

Destroy the wp_tablet_pad_group object. Objects created from this object are unaffected and should be destroyed separately.

Definition at line 6833 of file wayland-server-protocol-unstable.cpp.

## post_no_memory()

void wayland::server::resource_t::post_no_memory | ( |  | ) | const

inherited

Post "not enough memory" error to the client

If the compositor has not enough memory to fulfill a certail request of the client, this function can be called to notify the client of this circumstance.

## proxy_has_object()

bool wayland::server::resource_t::proxy_has_object | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## ring()

void zwp_tablet_pad_group_v2_t::ring | ( | bool | post = true | ) |

ring announced

Sent on wp_tablet_pad_group initialization to announce available rings. One event is sent for each ring available on this pad group.

This event is sent in the initial burst of events before the wp_tablet_pad_group.done event.

Definition at line 6844 of file wayland-server-protocol-unstable.cpp.

## strip()

void zwp_tablet_pad_group_v2_t::strip | ( | bool | post = true | ) |

strip announced

Sent on wp_tablet_pad initialization to announce available strips. One event is sent for each strip available on this pad group.

This event is sent in the initial burst of events before the wp_tablet_pad_group.done event.

Definition at line 6849 of file wayland-server-protocol-unstable.cpp.

## Member Data Documentation

## buttons_since_version

std::uint32_t wayland::server::zwp_tablet_pad_group_v2_t::buttons_since_version = 1

static constexpr

Minimum protocol version required for the buttons function.

Definition at line 6049 of file wayland-server-protocol-unstable.hpp.

## done_since_version

std::uint32_t wayland::server::zwp_tablet_pad_group_v2_t::done_since_version = 1

static constexpr

Minimum protocol version required for the done function.

Definition at line 6116 of file wayland-server-protocol-unstable.hpp.

## mode_switch_since_version

std::uint32_t wayland::server::zwp_tablet_pad_group_v2_t::mode_switch_since_version = 1

static constexpr

Minimum protocol version required for the mode_switch function.

Definition at line 6156 of file wayland-server-protocol-unstable.hpp.

## modes_since_version

std::uint32_t wayland::server::zwp_tablet_pad_group_v2_t::modes_since_version = 1

static constexpr

Minimum protocol version required for the modes function.

Definition at line 6102 of file wayland-server-protocol-unstable.hpp.

## ring_since_version

std::uint32_t wayland::server::zwp_tablet_pad_group_v2_t::ring_since_version = 1

static constexpr

Minimum protocol version required for the ring function.

Definition at line 6064 of file wayland-server-protocol-unstable.hpp.

## strip_since_version

std::uint32_t wayland::server::zwp_tablet_pad_group_v2_t::strip_since_version = 1

static constexpr

Minimum protocol version required for the strip function.

Definition at line 6079 of file wayland-server-protocol-unstable.hpp.

The documentation for this class was generated from the following files:

- obj-x86_64-linux-gnu/wayland-server-protocol-unstable.hpp
- obj-x86_64-linux-gnu/wayland-server-protocol-unstable.cpp